<?php
namespace Teknisa\CADSUP\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\FilterCriteria;

class Sup04100FornecedorInativoController
{

    protected $cadSupUtil;
    protected $crudService;
    protected $dataSourceName = 'fornecedor_inativo';

    public function __construct($cadSupUtil, $crudService) 
    {

        $this->cadSupUtil          = $cadSupUtil;
        $this->crudService         = $crudService;
        
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) 
    {

        $oldFilterCriteria = $request->getFilterCriteria();
        $filters = $oldFilterCriteria->getConditions();
        $item_list = array();
        $params = [ 
            'P_DTINI',
            'P_DTFIN',
            'P_CONSIDERA',
            'L_CDFORNECED',
            'L_CDFILIAL',
        ];

        $queryParams = array();
        
        $NRLISTA_FILIAL = null;
        $NRLISTA_FORNECEDOR = null;
        
        foreach($filters as $filter) {
            if($filter['columnName'] === 'NMFILIAL') {

                $NRLISTA_FILIAL = $this->cadSupUtil->insertLista($filter['value']);
                $queryParams[] = $this->setTemplate('L_CDFILIAL', $NRLISTA_FILIAL);
                
                
            } else if($filter['columnName'] === 'NMFORNECEDOR') {
                
                $NRLISTA_FORNECEDOR = $this->cadSupUtil->insertLista($filter['value']);
                
                $queryParams[] = $this->setTemplate('L_CDFORNECED', $NRLISTA_FORNECEDOR);
                
                
            } else if($filter['columnName'] === 'INTERVAL_DT') {
                
                $queryParams[] = $this->setTemplate('P_DTINI', $filter['value'][0]);
                $queryParams[] = $this->setTemplate('P_DTFIN', $filter['value'][1]);
                
            } else if($filter['columnName'] === 'TIPO') {
                
                $queryParams[] = $this->setTemplate('P_CONSIDERA', $filter['value']);
                
            } else {
                $queryParams[] = ($filter);
            }
        }
        
        
        $page = $oldFilterCriteria->getPage();
        $pageSize = $oldFilterCriteria->getPageSize();
        $filterCriteria = new FilterCriteria($this->dataSourceName, $queryParams, $page, $pageSize);
        
        $filterCriteria = $this->crudService->getFilterCriteriaWithNrOrg($filterCriteria);
        
        $filterCriteria = $this->crudService->getPopulatedFilterCriteria($filterCriteria, $params);
        
        $this->crudService->find($response, $filterCriteria);
        
        $this->cadSupUtil->deleteLista($NRLISTA_FILIAL);

        $this->cadSupUtil->deleteLista($NRLISTA_FORNECEDOR);
        
    }
    
    protected function setTemplate($name, $value, $operator = '=') {
        return $currentParameter = array(
            'columnName' => $name,
            'operator'   => $operator,
            'value'      => $value
        );
    }
    
}